DiscountTable extends DataManager
Class DiscountTable
Fields:
- ID int mandatory
- XML_ID string(255) optional
- LID string(2) mandatory
- NAME string(255) optional
- PRICE_FROM float optional
- PRICE_TO float optional
- CURRENCY string(3) optional
- DISCOUNT_VALUE float mandatory
- DISCOUNT_TYPE string(1) mandatory default 'P'
- ACTIVE bool optional default 'Y'
- SORT int optional default 100
- ACTIVE_FROM datetime optional
- ACTIVE_TO datetime optional
- TIMESTAMP_X datetime optional
- MODIFIED_BY int optional
- DATE_CREATE datetime optional
- CREATED_BY int optional
- PRIORITY int optional default 1
- LAST_DISCOUNT bool optional default 'Y'
- VERSION int optional default 3
- CONDITIONS text optional
- CONDITIONS_LIST text optional
- UNPACK text optional
- ACTIONS text optional
- ACTIONS_LIST text optional
- APPLICATION text optional
- PREDICTION_TEXT text optional
- PREDICTIONS text optional
- PREDICTIONS_APP text optional
- USE_COUPONS bool optional default 'N'
- USE_INDEX bool optional default 'N'
- PRESET_ID string optional
- EXECUTE_MODULE string(50) mandatory default 'all'
- EXECUTE_MODE int default 0
- CREATED_BY_USER reference to [](\Bitrix\Main\UserTable)
- MODIFIED_BY_USER reference to [](\Bitrix\Main\UserTable)
Table of Contents
Constants
- EVENT_ON_ADD = "OnAdd"
- EVENT_ON_AFTER_ADD = "OnAfterAdd"
- EVENT_ON_AFTER_DELETE = "OnAfterDelete"
- EVENT_ON_AFTER_UPDATE = "OnAfterUpdate"
- EVENT_ON_BEFORE_ADD = "OnBeforeAdd"
- EVENT_ON_BEFORE_DELETE = "OnBeforeDelete"
- EVENT_ON_BEFORE_UPDATE = "OnBeforeUpdate"
- EVENT_ON_DELETE = "OnDelete"
- EVENT_ON_UPDATE = "OnUpdate"
- EXECUTE_MODE_GENERAL = 0
- EXECUTE_MODE_SEPARATELY = 2
- VERSION_15 = 0x3
- VERSION_NEW = 0x2
- VERSION_OLD = 0x1
Methods
- add() : AddResult
- Adds row to entity table
- addMulti() : AddResult
- Adds several rows to entity table.
- checkFields() : mixed
- Checks the data fields before saving to DB. Result stores in the $result object
- cleanCache() : void
- Cleans the tablet cache after data modifications.
- createCollection() : EO_Discount_Collection
- createObject() : EO_Discount
- cryptoEnabled() : bool
- Returns true if crypto is enabled for a field.
- delete() : DeleteResult
- Deletes row in entity table by primary key
- enableCrypto() : mixed
- Sets a flag indicating crypto support for a field.
- getById() : EO_Discount_Result
- Returns selection by entity's primary key
- getByPrimary() : EO_Discount_Result
- Returns selection by entity's primary key and optional parameters for getList()
- getCollectionClass() : string|Collection
- Returns class of Object collection for current entity.
- getCollectionClassName() : string
- Returns class name (without namespace) of Object collection for current entity.
- getCollectionParentClass() : Collection|string
- getConnectionName() : string
- Returns connection name for entity
- getCount() : int
- Performs COUNT query on entity and returns the result.
- getEntity() : EO_Discount_Entity
- Returns entity object
- getEntityClass() : Entity|string
- getList() : EO_Discount_Result
- Executes the query and returns selection by parameters of the query. This function is an alias to the Query object functions
- getMap() : array<string|int, mixed>
- Returns entity map definition.
- getObjectClass() : string|EntityObject
- Returns class of Object for current entity.
- getObjectClassName() : string
- Returns class name (without namespace) of Object for current entity.
- getObjectParentClass() : EntityObject|string
- getQueryClass() : Query|string
- getRow() : array<string|int, mixed>|null
- Returns one row (or null) by parameters for getList()
- getRowById() : array<string|int, mixed>|null
- Returns one row (or null) by entity's primary key
- getTableName() : string
- Returns DB table name for entity.
- getTitle() : string|null
- getUfId() : mixed
- isCacheable() : bool
- You can disable cache for the tablet completely.
- isUtm() : mixed
- isUts() : mixed
- onAdd() : mixed
- onAfterAdd() : void
- Default onAfterAdd handler. Absolutely necessary.
- onAfterDelete() : void
- Default onAfterDelete handler. Absolutely necessary.
- onAfterUpdate() : void
- Default onAfterUpdate handler. Absolutely necessary.
- onBeforeAdd() : EventResult
- Default onBeforeAdd handler. Absolutely necessary.
- onBeforeDelete() : mixed
- onBeforeUpdate() : EventResult
- Default onBeforeUpdate handler. Absolutely necessary.
- onDelete() : void
- Default onDelete handler. Absolutely necessary.
- onUpdate() : mixed
- postInitialize() : null
- query() : EO_Discount_Query
- Creates and returns the Query object for the entity
- setAllUseCoupons() : void
- Set exist coupons flag for all discounts.
- setCurrentDeletingObject() : void
- setDefaultScope() : Query
- setUseCoupons() : void
- Set exist coupons flag for discount list.
- unsetEntity() : mixed
- update() : UpdateResult
- Updates row in entity table by primary key
- updateMulti() : UpdateResult
- validateCurrency() : array<string|int, mixed>
- Returns validators for CURRENCY field.
- validateDiscountType() : array<string|int, mixed>
- Returns validators for DISCOUNT_TYPE field.
- validateExecuteModule() : array<string|int, mixed>
- Returns validators for EXECUTE_MODULE field.
- validateLid() : array<string|int, mixed>
- Returns validators for LID field.
- validateName() : array<string|int, mixed>
- Returns validators for NAME field.
- validatePresetId() : array<string|int, mixed>
- Returns validators for PRESET_ID field.
- validateXmlId() : array<string|int, mixed>
- Returns validators for XML_ID field.
- wakeUpCollection() : EO_Discount_Collection
- wakeUpObject() : EO_Discount
Constants
EVENT_ON_ADD
public
mixed
EVENT_ON_ADD
= "OnAdd"
EVENT_ON_AFTER_ADD
public
mixed
EVENT_ON_AFTER_ADD
= "OnAfterAdd"
EVENT_ON_AFTER_DELETE
public
mixed
EVENT_ON_AFTER_DELETE
= "OnAfterDelete"
EVENT_ON_AFTER_UPDATE
public
mixed
EVENT_ON_AFTER_UPDATE
= "OnAfterUpdate"
EVENT_ON_BEFORE_ADD
public
mixed
EVENT_ON_BEFORE_ADD
= "OnBeforeAdd"
EVENT_ON_BEFORE_DELETE
public
mixed
EVENT_ON_BEFORE_DELETE
= "OnBeforeDelete"
EVENT_ON_BEFORE_UPDATE
public
mixed
EVENT_ON_BEFORE_UPDATE
= "OnBeforeUpdate"
EVENT_ON_DELETE
public
mixed
EVENT_ON_DELETE
= "OnDelete"
EVENT_ON_UPDATE
public
mixed
EVENT_ON_UPDATE
= "OnUpdate"
EXECUTE_MODE_GENERAL
public
mixed
EXECUTE_MODE_GENERAL
= 0
EXECUTE_MODE_SEPARATELY
public
mixed
EXECUTE_MODE_SEPARATELY
= 2
VERSION_15
public
mixed
VERSION_15
= 0x3
VERSION_NEW
public
mixed
VERSION_NEW
= 0x2
VERSION_OLD
public
mixed
VERSION_OLD
= 0x1
Methods
add()
Adds row to entity table
public
static add(array<string|int, mixed> $data) : AddResult
Parameters
- $data : array<string|int, mixed>
-
An array with fields like array( "fields" => array( "FIELD1" => "value1", "FIELD2" => "value2", ), "auth_context" => \Bitrix\Main\Authentication\Context object ) or just a plain array of fields.
This method uses the default strategy defined in the class.
Tags
Return values
AddResult —Contains ID of inserted row
addMulti()
Adds several rows to entity table.
public
static addMulti(mixed $rows[, bool $ignoreEvents = false ]) : AddResult
This method uses the default strategy defined in the class.
Parameters
- $rows : mixed
- $ignoreEvents : bool = false
Tags
Return values
AddResultcheckFields()
Checks the data fields before saving to DB. Result stores in the $result object
public
static checkFields(Result $result, mixed $primary, array<string|int, mixed> $data) : mixed
Parameters
- $result : Result
- $primary : mixed
- $data : array<string|int, mixed>
Tags
cleanCache()
Cleans the tablet cache after data modifications.
public
static cleanCache() : void
createCollection()
public
static createCollection() : EO_Discount_Collection
Return values
EO_Discount_CollectioncreateObject()
public
static createObject([mixed $setDefaultValues = = 'true' ]) : EO_Discount
Parameters
- $setDefaultValues : mixed = = 'true'
Return values
EO_DiscountcryptoEnabled()
Returns true if crypto is enabled for a field.
public
static cryptoEnabled(string $field[, string $table = null ]) : bool
Parameters
- $field : string
- $table : string = null
Return values
booldelete()
Deletes row in entity table by primary key
public
static delete(mixed $primary) : DeleteResult
Parameters
- $primary : mixed
Tags
Return values
DeleteResultenableCrypto()
Sets a flag indicating crypto support for a field.
public
static enableCrypto(string $field[, string $table = null ][, bool $mode = true ]) : mixed
Parameters
- $field : string
- $table : string = null
- $mode : bool = true
getById()
Returns selection by entity's primary key
public
static getById(mixed $id) : EO_Discount_Result
Parameters
- $id : mixed
-
Primary key of the entity
Return values
EO_Discount_ResultgetByPrimary()
Returns selection by entity's primary key and optional parameters for getList()
public
static getByPrimary(mixed $primary[, array<string|int, mixed> $parameters = = '[]' ]) : EO_Discount_Result
Parameters
- $primary : mixed
-
Primary key of the entity
- $parameters : array<string|int, mixed> = = '[]'
-
Additional parameters for getList()
Return values
EO_Discount_ResultgetCollectionClass()
Returns class of Object collection for current entity.
public
static getCollectionClass() : string|Collection
Return values
string|CollectiongetCollectionClassName()
Returns class name (without namespace) of Object collection for current entity.
public
final static getCollectionClassName() : string
Return values
stringgetCollectionParentClass()
public
static getCollectionParentClass() : Collection|string
Return values
Collection|stringgetConnectionName()
Returns connection name for entity
public
static getConnectionName() : string
Return values
stringgetCount()
Performs COUNT query on entity and returns the result.
public
static getCount([array<string|int, mixed>|ConditionTree $filter = array() ][, array<string|int, mixed> $cache = array() ]) : int
Parameters
- $filter : array<string|int, mixed>|ConditionTree = array()
- $cache : array<string|int, mixed> = array()
-
An array of cache options "ttl" => integer indicating cache TTL
Tags
Return values
intgetEntity()
Returns entity object
public
static getEntity() : EO_Discount_Entity
Return values
EO_Discount_EntitygetEntityClass()
public
static getEntityClass() : Entity|string
Return values
Entity|stringgetList()
Executes the query and returns selection by parameters of the query. This function is an alias to the Query object functions
public
static getList([array<string|int, mixed> $parameters = = '[]' ]) : EO_Discount_Result
Parameters
- $parameters : array<string|int, mixed> = = '[]'
-
An array of query parameters, available keys are:
"select" => array of fields in the SELECT part of the query, aliases are possible in the form of "alias"=>"field";
"filter" => array of filters in the WHERE/HAVING part of the query in the form of "(condition)field"=>"value"; also could be an instance of Filter;
"group" => array of fields in the GROUP BY part of the query;
"order" => array of fields in the ORDER BY part of the query in the form of "field"=>"asc|desc";
"limit" => integer indicating maximum number of rows in the selection (like LIMIT n in MySql);
"offset" => integer indicating first row number in the selection (like LIMIT n, 100 in MySql);
"runtime" => array of entity fields created dynamically;
"cache => array of cache options:
"ttl" => integer indicating cache TTL;
"cache_joins" => boolean enabling to cache joins, false by default.
Return values
EO_Discount_ResultgetMap()
Returns entity map definition.
public
static getMap() : array<string|int, mixed>
Return values
array<string|int, mixed>getObjectClass()
Returns class of Object for current entity.
public
static getObjectClass() : string|EntityObject
Return values
string|EntityObjectgetObjectClassName()
Returns class name (without namespace) of Object for current entity.
public
final static getObjectClassName() : string
Return values
stringgetObjectParentClass()
public
static getObjectParentClass() : EntityObject|string
Return values
EntityObject|stringgetQueryClass()
public
static getQueryClass() : Query|string
Return values
Query|stringgetRow()
Returns one row (or null) by parameters for getList()
public
static getRow(array<string|int, mixed> $parameters) : array<string|int, mixed>|null
Parameters
- $parameters : array<string|int, mixed>
-
Primary key of the entity
Tags
Return values
array<string|int, mixed>|nullgetRowById()
Returns one row (or null) by entity's primary key
public
static getRowById(mixed $id[, array<string|int, mixed> $parameters = [] ]) : array<string|int, mixed>|null
Parameters
- $id : mixed
-
Primary key of the entity
- $parameters : array<string|int, mixed> = []
-
Additional parameters for getList()
Tags
Return values
array<string|int, mixed>|nullgetTableName()
Returns DB table name for entity.
public
static getTableName() : string
Return values
stringgetTitle()
public
static getTitle() : string|null
Return values
string|nullgetUfId()
public
static getUfId() : mixed
isCacheable()
You can disable cache for the tablet completely.
public
static isCacheable() : bool
Return values
boolisUtm()
public
static isUtm() : mixed
isUts()
public
static isUts() : mixed
onAdd()
public
static onAdd(Event $event) : mixed
Parameters
- $event : Event
onAfterAdd()
Default onAfterAdd handler. Absolutely necessary.
public
static onAfterAdd(Event $event) : void
Parameters
- $event : Event
-
Event object.
onAfterDelete()
Default onAfterDelete handler. Absolutely necessary.
public
static onAfterDelete(Event $event) : void
Parameters
- $event : Event
-
Event object.
onAfterUpdate()
Default onAfterUpdate handler. Absolutely necessary.
public
static onAfterUpdate(Event $event) : void
Parameters
- $event : Event
-
Event object.
onBeforeAdd()
Default onBeforeAdd handler. Absolutely necessary.
public
static onBeforeAdd(Event $event) : EventResult
Parameters
- $event : Event
-
Event object.
Return values
EventResultonBeforeDelete()
public
static onBeforeDelete(Event $event) : mixed
Parameters
- $event : Event
onBeforeUpdate()
Default onBeforeUpdate handler. Absolutely necessary.
public
static onBeforeUpdate(Event $event) : EventResult
Parameters
- $event : Event
-
Event object.
Return values
EventResultonDelete()
Default onDelete handler. Absolutely necessary.
public
static onDelete(Event $event) : void
Parameters
- $event : Event
-
Event object.
onUpdate()
public
static onUpdate(Event $event) : mixed
Parameters
- $event : Event
postInitialize()
public
static postInitialize(Entity $entity) : null
Parameters
- $entity : Entity
Return values
nullquery()
Creates and returns the Query object for the entity
public
static query() : EO_Discount_Query
Return values
EO_Discount_QuerysetAllUseCoupons()
Set exist coupons flag for all discounts.
public
static setAllUseCoupons(string $use) : void
Parameters
- $use : string
-
Value for update use coupons for all discount.
setCurrentDeletingObject()
public
static setCurrentDeletingObject(EntityObject $object) : void
Parameters
- $object : EntityObject
setDefaultScope()
public
static setDefaultScope(Query $query) : Query
Parameters
- $query : Query
Return values
QuerysetUseCoupons()
Set exist coupons flag for discount list.
public
static setUseCoupons(array<string|int, mixed> $discountList, string $use) : void
Parameters
- $discountList : array<string|int, mixed>
-
Discount ids for update.
- $use : string
-
Value for update use coupons.
unsetEntity()
public
static unsetEntity(mixed $class) : mixed
Parameters
- $class : mixed
update()
Updates row in entity table by primary key
public
static update(mixed $primary, array<string|int, mixed> $data) : UpdateResult
Parameters
- $primary : mixed
- $data : array<string|int, mixed>
-
An array with fields like array( "fields" => array( "FIELD1" => "value1", "FIELD2" => "value2", ), "auth_context" => \Bitrix\Main\Authentication\Context object ) or just a plain array of fields.
Tags
Return values
UpdateResultupdateMulti()
public
static updateMulti(array<string|int, mixed> $primaries, array<string|int, mixed> $data[, bool $ignoreEvents = false ]) : UpdateResult
Parameters
- $primaries : array<string|int, mixed>
- $data : array<string|int, mixed>
- $ignoreEvents : bool = false
Tags
Return values
UpdateResultvalidateCurrency()
Returns validators for CURRENCY field.
public
static validateCurrency() : array<string|int, mixed>
Return values
array<string|int, mixed>validateDiscountType()
Returns validators for DISCOUNT_TYPE field.
public
static validateDiscountType() : array<string|int, mixed>
Return values
array<string|int, mixed>validateExecuteModule()
Returns validators for EXECUTE_MODULE field.
public
static validateExecuteModule() : array<string|int, mixed>
Return values
array<string|int, mixed>validateLid()
Returns validators for LID field.
public
static validateLid() : array<string|int, mixed>
Return values
array<string|int, mixed>validateName()
Returns validators for NAME field.
public
static validateName() : array<string|int, mixed>
Return values
array<string|int, mixed>validatePresetId()
Returns validators for PRESET_ID field.
public
static validatePresetId() : array<string|int, mixed>
Return values
array<string|int, mixed>validateXmlId()
Returns validators for XML_ID field.
public
static validateXmlId() : array<string|int, mixed>
Return values
array<string|int, mixed>wakeUpCollection()
public
static wakeUpCollection(mixed $rows) : EO_Discount_Collection
Parameters
- $rows : mixed
Return values
EO_Discount_CollectionwakeUpObject()
public
static wakeUpObject(mixed $row) : EO_Discount
Parameters
- $row : mixed